/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file MsgLoggerDebugger.cpp
 *       @see MUST::MsgLoggerDebugger.
 *
 *  @date 20.01.2011
 *  @author Tobias Hilbrich
 */

#include "GtiMacros.h"

#include "MsgLoggerDebugger.h"

using namespace must;

mGET_INSTANCE_FUNCTION(MsgLoggerDebugger);
mFREE_INSTANCE_FUNCTION(MsgLoggerDebugger);
mPNMPI_REGISTRATIONPOINT_FUNCTION(MsgLoggerDebugger);

//=============================
// Constructor
//=============================
MsgLoggerDebugger::MsgLoggerDebugger (const char* instanceName)
    : gti::ModuleBase<MsgLoggerDebugger, I_MessageLogger> (instanceName),
      myPIdModule (NULL),
      myLIdModule (NULL)
{
    //create sub modules
    std::vector<I_Module*> subModInstances;
    subModInstances = createSubModuleInstances ();

    //save sub modules
    myLIdModule = (I_LocationAnalysis*) subModInstances[0];
    myPIdModule = (I_ParallelIdAnalysis*) subModInstances[1];
}

//=============================
// Destructor
//=============================
MsgLoggerDebugger::~MsgLoggerDebugger (void)
{
	if (myLIdModule)
		destroySubModuleInstance ((I_Module*) myLIdModule);
	myLIdModule = NULL;

	if (myPIdModule)
		destroySubModuleInstance ((I_Module*) myPIdModule);
	myPIdModule = NULL;
}

//=============================
// log
//=============================
GTI_ANALYSIS_RETURN MsgLoggerDebugger::log (
					int msgId,
					int hasLocation,
					uint64_t pId,
					uint64_t lId,
					int msgType,
					char *text,
					int textLen,
					int numReferences,
					uint64_t* refPIds,
					uint64_t* refLIds)
{

	switch ((MustMessageType)msgType)
	{
	case MustErrorMessage:
		break;
	default:
        return GTI_ANALYSIS_SUCCESS;
	}


    std::cout
            << "Stopping process " << getpid() << ": " << std::endl
            << "gdb -p " << getpid()
		<< std::endl;

	std::cout.flush();

    bool loop=true;
    while (loop)
        sleep(1);
    
    
	return GTI_ANALYSIS_SUCCESS;
}

/*EOF*/
